#include <Servo.h>

int pos_left = 85;
int pos_right = 95;
Servo eyeservo;
Servo mouthservo;
const int trig_Pin_L = 10;  //Initialize I/O pins
const int echo_Pin_L = 11;
const int trig_Pin_R = 12;  //Initialize I/O pins
const int echo_Pin_R = 13;
const int photocellPin = 0; // Photoresistor at Arduino analog pin A0  
long duration_L;
long duration_R;//Since PulseIn return an unsigned Long 
int distance_L;
int distance_R;//To save the distance
int photocellReading;

#include "Arduino.h"
#include "SoftwareSerial.h"
#include "DFRobotDFPlayerMini.h"

SoftwareSerial mySoftwareSerial(6, 7); // RX, TX
DFRobotDFPlayerMini myDFPlayer;
void printDetail(uint8_t type, int value);

void setup()
{
  eyeservo.attach(9);
  mouthservo.attach(8);
  pinMode(echo_Pin_L, INPUT);      //Echo pin as Input
  pinMode(trig_Pin_L, OUTPUT);
  pinMode(echo_Pin_R, INPUT);      //Echo pin as Input
  pinMode(trig_Pin_R, OUTPUT); //Trigger pin as Output
  pinMode(A0, INPUT);
  mySoftwareSerial.begin(9600);
  Serial.begin(115200); //Initialize Serial communication
  Serial.println();
  Serial.println(F("DFRobot DFPlayer Mini Demo"));
  Serial.println(F("Initializing DFPlayer ... (May take 3~5 seconds)"));
  
  if (!myDFPlayer.begin(mySoftwareSerial)) {  //Use softwareSerial to communicate with mp3.
    Serial.println(F("Unable to begin:"));
    Serial.println(F("1.Please recheck the connection!"));
    Serial.println(F("2.Please insert the SD card!"));
    while(true);
  }
  Serial.println(F("DFPlayer Mini online."));
  
  myDFPlayer.setTimeOut(500); //Set serial communictaion time out 500ms
  
  //----Set volume----
  myDFPlayer.volume(30);  //Set volume value (0~30).
  myDFPlayer.volumeUp(); //Volume Up
  myDFPlayer.volumeDown(); //Volume Down
  
  //----Set different EQ----
  myDFPlayer.EQ(DFPLAYER_EQ_NORMAL);
  myDFPlayer.outputDevice(DFPLAYER_DEVICE_SD);
}

void loop(){
//  int lightRead = analogRead(A0);
//  delay(5);
  digitalWrite(trig_Pin_L, LOW);
  delayMicroseconds(2);
  digitalWrite(trig_Pin_L, HIGH);
  delayMicroseconds(10);
  digitalWrite(trig_Pin_L, LOW);
  duration_L = pulseIn(echo_Pin_L, HIGH);
  distance_L = duration_L*0.034/2; 
  Serial.print("Distance_left: ");
  Serial.println(distance_L);
  digitalWrite(trig_Pin_R, LOW);
  delayMicroseconds(2);
  digitalWrite(trig_Pin_R, HIGH);
  delayMicroseconds(10);
  digitalWrite(trig_Pin_R, LOW);
  duration_R = pulseIn(echo_Pin_R, HIGH);
  distance_R = duration_R*0.034/2; 
  Serial.print("Distance_right: ");
  Serial.println(distance_R);
  
  if (distance_L<distance_R){
    photocellReading = analogRead(photocellPin);  
    Serial.print("Analog reading = ");
    Serial.println(photocellReading);     // the raw analog reading 
    
    if (photocellReading>300){
    Serial.println("Rotate Left Side");
    eyeservo.write(pos_left);
    delay(15);
    myDFPlayer.playFolder(10, 1);  //play specific mp3 in SD:/15/004.mp3; Folder Name(1~99); File Name(1~255)
    for (int i=0; i<2; i+=1){
      mouthservo.write(15);
      delay(200);
      mouthservo.write(20);
      delay(200);
      mouthservo.write(15);
      }
      delay(5000);
      }
  }
  if (distance_L>distance_R){
    photocellReading = analogRead(photocellPin);  
    Serial.print("Analog reading = ");
    Serial.println(photocellReading);     // the raw analog reading 
    
    if (photocellReading>300){
      Serial.println("Rotate Right Side"); 
      eyeservo.write(pos_right);
      delay(15);
      myDFPlayer.playFolder(10, 2);  //play specific mp3 in SD:/15/004.mp3; Folder Name(1~99); File Name(1~255)
      for (int i=0; i<5; i+=1){
        mouthservo.write(15);
        delay(100);
        mouthservo.write(20);
        delay(150);
        mouthservo.write(15);
        }
        delay(500);
        for (int i=0; i<5; i+=1){
        mouthservo.write(15);
        delay(100);
        mouthservo.write(20);
        delay(150);
        mouthservo.write(15);
        }
        delay(700);
        for (int i=0; i<10; i+=1){
        mouthservo.write(15);
        delay(100);
        mouthservo.write(20);
        delay(150);
        mouthservo.write(15);
        }
        delay(700);
        for (int i=0; i<10; i+=1){
        mouthservo.write(15);
        delay(100);
        mouthservo.write(20);
        delay(150);
        mouthservo.write(15);
        }
        delay(5000);
        }
        }
}
